LE(1)

NAME
le - full screen text editor

SYNOPSIS
le [options] filename

DESCRIPTION
le is a text editor which offers wide range of capabilities with a simple interface. It has a pull down menu and a simple help system to get started. See KEYS section below to learn about key combinations.

Among its features there are: various operations with stream and rectangular blocks, search and replace with full regular expressions, text formatting, undelete/uninsert, hex editing, tunable key sequences, tunable colors, tunable syntax highlighting.

The editor currently supports only one loaded file at a time.

KEYS
Here are some starting hints:

F10 or C-n
    menu

F1  help

C-x exit (cancel)

Arrows
    navigate

In the editor the following key description is used:

Key1-Key2
    simultaneous key1 and key2 press

Key1+Key2
    sequential keys press

Key1 | Key2
    press Key1 OR Key2

^Key
    Ctrl-Key

~Key
    Shift-Key

^~Key
    Ctrl-Shift-Key | Alt-Key

Some of ^Fx, ~Fx, ^~Fx can be typed as ESC+Fx.

The rest of key combinations can be seen in help, in menu and in the keyboard map (default one can be seen with le --dump-keymap).

There is support for block filtering through an external program, a command output read-in, writing a block through a command. To read or write block from/to a command, use F4+R or F4+W and file name of the following format: ``|command args''. Filtering is achieved by F4+| followed by command name.

STATUS LINE
On the status line you can see current line, column, the size of loaded file, the code of character under cursor, several one letter flags, file name, offset in bytes from the file beginning and percent position in the file.

One letters flags are: * - modified; R - Russian keyboard (works only on certain terminals); I - insert, O - overstrike; A - autoindent; D - dos style line terminators (CR NL); U - undelete possible, u - uninsert possible; B - column block mode.

TEXT PROTECTION
To prevent changes loss on crash, le regularly dumps the editing text, if changed, to ~/.le/tmp/FILENAME.PID , where FILENAME is the file name with slashes converted to underlines; PID is the process id of the editor process.

When the editor gets a fatal signal, it also dumps the text, to ~/.le/tmp/DUMP-SIG-FILENAME.PID , where SIG is the signal number.

OPTIONS

-r, --read-only
    Work as viewer, don't allow changes. If your system supports mmap(2), it will be used to get file contents to memory.

-h, --hex-mode
    Start in hex mode

--mmap
    Use mmap(2) to load file read-only. Can be used to view very large files or even devices. This implies -h.

--mmap-rw
    Use mmap(2) to load file read-write in MAP_SHARED mode. Use with caution -- the changes go directly to file or disk, no undo. In this mode only replace can be used, but it allows editing of very large files or even devices. This implies -h.

--multibyte
    Force multibyte mode on. Multibyte mode is usually enabled automatically as needed.

--no-multibyte
    Force multibyte mode off, even if it was automatically determined that it should be on.

-b, --black-white
    Start in black & white mode

-c, --color
    Start in color mode

--dump-keymap
    Dump default keymap to stdout and exit

--dump-colors
    Dump default color map to stdout and exit

--version
    Print the version of LE and exit

--help
    Print short description of options and exit

ENVIRONMENT VARIABLES
The following environment variables are processed by le:

HOME
    Used for tilde (`~') expansion.

LE_DEFAULT_EOL
    The default EOL marker. It can be set to NL (\n), CRNL (\r\n) or CR (\r). Also it can be set to any other 1-2 character string interpreted literally.

TERM, LINES, COLUMNS
    These variables are used by curses library for full-screen output.

FILES

DATADIR/colors
~/.le/colors
DATADIR/colors-$TERM
~/.le/colors-$TERM
    Color palette description. Those files are sequentially read and color definitions in later files have higher precision.

~/.le/keymap-$TERM
DATADIR/keymap-$TERM
~/.le/keymap
DATADIR/keymap
    Key map descriptions. Only the first existing file is read.

~/.le/term-$TERM
DATADIR/term-$TERM
    Terminal specific options. Only the first existing file is read. Use Options->Terminal menu to tune the options.

./.le.ini
~/.le/le.ini
DATADIR/le.ini
    Options. Only the first existing file is read. Use menu Options to tune these.

.le.syntax
~/.le/syntax
DATADIR/syntax
    Syntax highlighting rules. Only the first existing file is read. There is no default built-in in the editor, so if those files are not present you won't see any syntax highlighting.

~/.le/mainmenu
DATADIR/mainmenu
    Main editor menu. It has simple text format. Only the first existing file is read.

~/.le/history
    Various histories are saved here. Do not edit by hand.

DATADIR is determined at compile time by configure script (pkgdatadir variable). By default it has value /usr/local/share/le.

AUTHOR
The LE editor was written by Alexander V. Lukyanov <lav@yars.free.net>.